#ifndef __SMCC_STRPOOL_H__
#define __SMCC_STRPOOL_H__

#include <lib/core.h>
#include <lib/rt/rt_alloc.h>
#include <lib/utils/ds/hashtable.h>

typedef struct strpool {
    hash_table_t ht;       // 用于快速查找字符串
    long_alloc_t stralloc; // 专门用于字符串存储的分配器
} strpool_t;

void init_strpool(strpool_t* pool);
const char* strpool_intern(strpool_t* pool, const char* str);
void strpool_destroy(strpool_t* pool);

#endif // __SMCC_STRPOOL_H__
