#include "riscv32_asm.h"

void init_rv32_prog(rv32_prog_t* prog, strpool_t* strpool) {
    if (strpool == NULL) {
        prog->strpool = salloc_alloc(sizeof(strpool_t));
        init_strpool(prog->strpool);
    } else {
        prog->strpool = strpool;
    }
    prog->data_base_address = 0;
    vector_init(prog->data);
    prog->text_base_address = 0;
    init_symtab_asm(&prog->symtab);
    init_rv32_mcode(&prog->mcode, sizeof(symasm_entry_t));
}
